374 & amp; 375. Guess Number Higher or Lower 1 & amp; 2, Sanchez

Source: Internet
Author: User

374 & 375. Guess Number Higher or Lower 1 & 2, Sanchez

Question about leetcode

 

We are playing the Guess Game. The game is as follows:

 

I pick a number from 1N. You have to guess which number I picked.

Every time you guess wrong, I'll tell you whether the number is higher or lower.

You call a pre-defined APIguess(int num)Which returns 3 possible results (-1,1, Or0):

-1 : My number is lower 1 : My number is higher 0 : Congrats! You got it!

Example:

N = 10, I pick 6. Return 6.

This is basically the case: the key lies in how to find and how to get guess;

Basic Points: Search/random; (parameter) recursion;
Advanced: TLE troubleshooting --

Mid = (low + high)/2;
Mid = low + (high-low)/2;

The first calculation method uses Time Limit Exceeded, probably because the result of (low + high) exceeds the maximum range of int and is out of bounds.

You can use the first formula, but change the data to the long type. You can also change it to the mid = low/2 + high/2 formula.

Reference from http://blog.csdn.net/y12345678904/article/details/51898958;

Then pay attention to the questions and check the details of guess and guessNum.

/* The guess API is defined in the parent class GuessGame.   @param num, your guess   @return -1 if my number is lower, 1 if my number is higher, otherwise return 0      int guess(int num); */public class Solution extends GuessGame {    public int guessNumber(int n) {        if (guess(n)== 0) return n;        int left=0;        int right=n;        while (left<right) {          int mid=left+(right-left)/2;          int re=guess(mid);          if (re==0){              return mid;          }else if(guess(mid)==-1){            right=mid;          }else{            left=mid;          }         // return left;        }        return left;    }}

375. Guess Number Higher or Lower II

We are playing the Guess Game. The game is as follows:

 

I pick a number from 1 to n. You have to guess which number I picked.

Every time you guess wrong, I'll tell you whether the number I picked is higher or lower.

However, when you guess a participant number x, and you guess wrong, you pay $ x. You win the game when you guess the number I picked.

Example:

n = 10, I pick 8.First round:  You guess 5, I tell you that it's higher. You pay $5.Second round: You guess 7, I tell you that it's higher. You pay $7.Third round:  You guess 9, I tell you that it's lower. You pay $9.Game over. 8 is the number I picked.You end up paying $5 + $7 + $9 = $21.

 

Given a participant n ≥ 1, find out how much money you need to have to guarantee a win.

Hint:

  1. The best strategy to play the game is to minimize the maximum loss you cocould possibly face. Another strategy is to minimize the expected loss. Here, we are interested in thefirst scenario.
  2. Take a small example (n = 3). What do you end up paying in the worst case?
  3. Check out this article if you're still stuck.
  4. The purely recursive implementation of minimax wocould be worthless for even a small n. You MUST use dynamic programming.
  5. As a follow-up, how wocould you modify your code to solve the problem of minimizing the expected loss, instead of the worst-case loss?

The basic idea is to minimize the maximum algorithm, that is, to find the maximum value, but the smallest of the maximum values. The logic should be clear. In two steps, find the maximum value, find the minimum value of the maximum value;

Basic implementation: recursion. -- here we use another two-dimensional array to compare the number and position of two-dimensional arrays to analyze the number of n. -- http://www.cnblogs.com/neweracoding/p/5679936.html;

public class Solution {  public int getMoneyAmount(int n) {    int[][] table = new int[n + 1][n + 1];  //0    return payForRange(table, 1, n);  }  //return the amount paid for the game within range [start,end]  private int payForRange(int[][] dp, int start, int end) {    if (start >= end)      return 0;    if (dp[start][end] != 0)      return dp[start][end];    int minimumForCurrentRange = Integer.MAX_VALUE;    for (int x = start; x <= end; ++x) {      //calculate the amount to pay if pick x.      int pay = x + Math.max(payForRange(dp, start, x - 1), payForRange(dp, x + 1, end));      //calculate min of maxes      minimumForCurrentRange = Math.min(minimumForCurrentRange, pay);    }    dp[start][end] = minimumForCurrentRange;    return minimumForCurrentRange;  }}

 

This recursion is performed orally by me ....

 

Contact Us

The content source of this page is from Internet, which doesn't represent Alibaba Cloud's opinion; products and services mentioned on that page don't have any relationship with Alibaba Cloud. If the content of the page makes you feel confusing, please write us an email, we will handle the problem within 5 days after receiving your email.

If you find any instances of plagiarism from the community, please send an email to: info-contact@alibabacloud.com and provide relevant evidence. A staff member will contact you within 5 working days.

A Free Trial That Lets You Build Big!

Start building with 50+ products and up to 12 months usage for Elastic Compute Service

  • Sales Support

    1 on 1 presale consultation

  • After-Sales Support

    24/7 Technical Support 6 Free Tickets per Quarter Faster Response

  • Alibaba Cloud offers highly flexible support services tailored to meet your exact needs.